#include "header.h"

// 1.1.7 : AVCC is the supply voltage pin for the A/D Converter, PC3:0, and ADC7:6
// 1.1.8 : AREF is the analog reference pin for the A/D Converter

#define ADC_PRESCALER	8

void int_to_hex_string(uint64_t value, char *out, uint8_t num_digits) {				// num_digits : number of digit of the output, ex 2 for 3FF (1023) -> FF
    for (uint8_t i = 0; i < num_digits; ++i) {
        uint8_t shift = (num_digits - 1 - i) * 4;
        out[i] = INT_TO_HEX_CHAR((value >> shift) & 0x0F);
    }
    out[num_digits] = '\0';
}

// description
int main() {
    char buffer[4];
	SREG |= ENABLE_GLOBAL_INTERRUPT;												// 7.3.1 : Status Register, bit 7 : I – Global Interrupt Enable
	uart_init();
	adc_init(ADC_PRESCALER);

	while(1) {
        uint16_t value = adc_read(0);												// Read from ADC0 (A0)
		int_to_hex_string(value, buffer, 3);
        uart_printstr_endl(buffer);
        _delay_ms(20);																// Wait 20ms
	}
}

// ISR(ADC_vect) {		// Table 12-6 : interrupt vector for ADC Conversion Complete
// }